Index: /trunk/src/sys/arch/mips/mips/locore_mips1.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/locore_mips1.S	(revision 152)
@@ -185,419 +222,778 @@
  * the compiler does it for us.
  */
-	subu	sp, sp, KERNFRAME_SIZ
-	sw	AT, TF_BASE+TF_REG_AST(sp)
-	sw	v0, TF_BASE+TF_REG_V0(sp)
-	sw	v1, TF_BASE+TF_REG_V1(sp)
+	PTR_SUBU sp, KERNFRAME_SIZ
+	REG_S	AT, TF_BASE+TF_REG_AST(sp)
+	REG_S	v0, TF_BASE+TF_REG_V0(sp)
+	REG_S	v1, TF_BASE+TF_REG_V1(sp)
 	mflo	v0
 	mfhi	v1
-	sw	a0, TF_BASE+TF_REG_A0(sp)
-	sw	a1, TF_BASE+TF_REG_A1(sp)
-	sw	a2, TF_BASE+TF_REG_A2(sp)
-	sw	a3, TF_BASE+TF_REG_A3(sp)
+	REG_S	a0, TF_BASE+TF_REG_A0(sp)
+	REG_S	a1, TF_BASE+TF_REG_A1(sp)
+	REG_S	a2, TF_BASE+TF_REG_A2(sp)
+	REG_S	a3, TF_BASE+TF_REG_A3(sp)
 	mfc0	a0, MIPS_COP_0_STATUS		# 1st arg is STATUS
-	sw	t0, TF_BASE+TF_REG_T0(sp)
-	sw	t1, TF_BASE+TF_REG_T1(sp)
-	sw	t2, TF_BASE+TF_REG_T2(sp)
-	sw	t3, TF_BASE+TF_REG_T3(sp)
+	REG_S	t0, TF_BASE+TF_REG_T0(sp)
+	REG_S	t1, TF_BASE+TF_REG_T1(sp)
+	REG_S	t2, TF_BASE+TF_REG_T2(sp)
+	REG_S	t3, TF_BASE+TF_REG_T3(sp)
 	mfc0	a1, MIPS_COP_0_CAUSE		# 2nd arg is CAUSE
-	sw	t4, TF_BASE+TF_REG_T4(sp)
-	sw	t5, TF_BASE+TF_REG_T5(sp)
-	sw	t6, TF_BASE+TF_REG_T6(sp)
-	sw	t7, TF_BASE+TF_REG_T7(sp)
-	mfc0	a2, MIPS_COP_0_BAD_VADDR	# 3rd arg is fault address
-	sw	t8, TF_BASE+TF_REG_T8(sp)
-	sw	t9, TF_BASE+TF_REG_T9(sp)
-	sw	ra, TF_BASE+TF_REG_RA(sp)
-	sw	a0, TF_BASE+TF_REG_SR(sp)
-	mfc0	a3, MIPS_COP_0_EXC_PC		# 4th arg is exception PC
-	sw	v0, TF_BASE+TF_REG_MULLO(sp)
-	sw	v1, TF_BASE+TF_REG_MULHI(sp)
-	sw	a3, TF_BASE+TF_REG_EPC(sp)
+	REG_S	ta0, TF_BASE+TF_REG_TA0(sp)
+	REG_S	ta1, TF_BASE+TF_REG_TA1(sp)
+	REG_S	ta2, TF_BASE+TF_REG_TA2(sp)
+	REG_S	ta3, TF_BASE+TF_REG_TA3(sp)
+	_MFC0	a2, MIPS_COP_0_BAD_VADDR	# 3rd arg is fault address
+	#REG_S	t8, TF_BASE+TF_REG_T8(sp)	# is MIPS_CURLWP
+	REG_S	t9, TF_BASE+TF_REG_T9(sp)
+	REG_S	ra, TF_BASE+TF_REG_RA(sp)
+	REG_S	a0, TF_BASE+TF_REG_SR(sp)
+	_MFC0	a3, MIPS_COP_0_EXC_PC		# 4th arg is exception PC
+	REG_S	v0, TF_BASE+TF_REG_MULLO(sp)
+	REG_S	v1, TF_BASE+TF_REG_MULHI(sp)
+	REG_S	a3, TF_BASE+TF_REG_EPC(sp)
+	REG_S	a1, TF_BASE+TF_REG_CAUSE(sp)
 #if defined(DDB) || defined(KGDB)
-	sw	s0, TF_BASE+TF_REG_S0(sp)
-	sw	s1, TF_BASE+TF_REG_S1(sp)
-	sw	s2, TF_BASE+TF_REG_S2(sp)
-	sw	s3, TF_BASE+TF_REG_S3(sp)
-	sw	s4, TF_BASE+TF_REG_S4(sp)
-	sw	s5, TF_BASE+TF_REG_S5(sp)
-	sw	s6, TF_BASE+TF_REG_S6(sp)
-	sw	s7, TF_BASE+TF_REG_S7(sp)
-	addu	v0, sp, KERNFRAME_SIZ
-	sw	v0, TF_BASE+TF_REG_SP(sp)
-	sw	s8, TF_BASE+TF_REG_S8(sp)
-	sw	gp, TF_BASE+TF_REG_GP(sp)
+	REG_S	s0, TF_BASE+TF_REG_S0(sp)
+	REG_S	s1, TF_BASE+TF_REG_S1(sp)
+	REG_S	s2, TF_BASE+TF_REG_S2(sp)
+	REG_S	s3, TF_BASE+TF_REG_S3(sp)
+	REG_S	s4, TF_BASE+TF_REG_S4(sp)
+	REG_S	s5, TF_BASE+TF_REG_S5(sp)
+	REG_S	s6, TF_BASE+TF_REG_S6(sp)
+	REG_S	s7, TF_BASE+TF_REG_S7(sp)
+	PTR_ADDU v0, sp, KERNFRAME_SIZ
+	REG_S	v0, TF_BASE+TF_REG_SP(sp)
+	REG_S	s8, TF_BASE+TF_REG_S8(sp)
+	REG_S	gp, TF_BASE+TF_REG_GP(sp)
 #endif
-	addu	v0, sp, TF_BASE
-	sw	v0, KERNFRAME_ARG5(sp)		# 5th arg is p. to trapframe
-/*
- * Call the trap handler.
- */
+	PTR_ADDU v0, sp, TF_BASE
+	REG_S	v0, KERNFRAME_ARG5(sp)		# 5th arg is p. to trapframe
+#ifdef PARANOIA
+	/*
+	 * save PPL in trapframe
+	 */
+	PTR_L	t0, L_CPU(MIPS_CURLWP)
+	nop
+	INT_L	t1, CPU_INFO_CPL(t0)		# get current priority level
+	nop
+	INT_S	t1, TF_BASE+TF_PPL(sp)		# save priority level
+#endif /* PARANOIA */
+
 #if defined(DDB) || defined(DEBUG) || defined(KGDB)
-	addu	v0, sp, KERNFRAME_SIZ
-	sw	v0, KERNFRAME_SP(sp)
+	PTR_ADDU v0, sp, KERNFRAME_SIZ
+	REG_S	v0, KERNFRAME_SP(sp)
 #endif
+
+#ifdef PARANOIA
+	/*
+	 * Verify our existing interrupt level.
+	 */
+	jal	_C_LABEL(splcheck)
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * Call the trap handler.
+	 */
 	jal	_C_LABEL(trap)
-	sw	a3,	KERNFRAME_RA(sp)	# for debugging
-/*
- * Restore registers and return from the exception.
- */
-	lw	a0, TF_BASE+TF_REG_SR(sp)
-	lw	t0, TF_BASE+TF_REG_MULLO(sp)
-	lw	t1, TF_BASE+TF_REG_MULHI(sp)
-	mtc0	a0, MIPS_COP_0_STATUS
+	 REG_S	a3, KERNFRAME_RA(sp)		# for debugging
+
+	/*
+	 * Restore registers and return from the exception.
+	 */
+	REG_L	a0, TF_BASE+TF_REG_SR(sp)
+	nop
+	mtc0	a0, MIPS_COP_0_STATUS		# restore the SR, disable intrs
+
+	/*
+	 * Start of common kernel exception return code for both
+	 * mipxN_kern_gen_exception and mipsN_kern_intr.
+	 */
+MIPSX(kern_return):
+	REG_L	t0, TF_BASE+TF_REG_MULLO(sp)
+	REG_L	t1, TF_BASE+TF_REG_MULHI(sp)
+	REG_L	k1, TF_BASE+TF_REG_EPC(sp)	# might be changed inside trap
 	mtlo	t0
 	mthi	t1
-/*
- * Check for kernel restartable atomic sequences.
- */
-	lw	k1, TF_BASE+TF_REG_EPC(sp)	# restore exception PC
-	la	t0, _C_LABEL(_lock_ras_start)
+
+#ifdef PARANOIA
+	INT_L	t2, TF_BASE+TF_PPL(sp)		# get saved priority level
+	PTR_L	t0, L_CPU(MIPS_CURLWP)
+	nop
+	INT_L	t1, CPU_INFO_CPL(t0)		# get current priority level
+	nop
+11:	bne	t2, t1, 11b			# loop forever if unequal
+	 nop
+
+	/*
+	 * Verify our existing interrupt level.
+	 */
+	jal	_C_LABEL(splcheck)
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * Check for kernel restartable atomic sequences.
+	 */
+	PTR_LA	t0, _C_LABEL(_lock_ras_start)
 	li	t1, -MIPS_LOCK_RAS_SIZE
-	and	t1, t1, k1
-	bne	t1, t0, 1f
-	nop
-	jal	_C_LABEL(_lock_ras)
+	and	t1, k1
+	bne	t1, t0, 1f			# exception PC in RAS area?
+	 nop
+	jal	_C_LABEL(_restart_lock_ras)	# fix the pc (k1)
+	 nop
 1:
-	lw	AT, TF_BASE+TF_REG_AST(sp)
-	lw	v0, TF_BASE+TF_REG_V0(sp)
-	lw	v1, TF_BASE+TF_REG_V1(sp)
-	lw	a0, TF_BASE+TF_REG_A0(sp)
-	lw	a1, TF_BASE+TF_REG_A1(sp)
-	lw	a2, TF_BASE+TF_REG_A2(sp)
-	lw	a3, TF_BASE+TF_REG_A3(sp)
-	lw	t0, TF_BASE+TF_REG_T0(sp)
-	lw	t1, TF_BASE+TF_REG_T1(sp)
-	lw	t2, TF_BASE+TF_REG_T2(sp)
-	lw	t3, TF_BASE+TF_REG_T3(sp)
-	lw	t4, TF_BASE+TF_REG_T4(sp)
-	lw	t5, TF_BASE+TF_REG_T5(sp)
-	lw	t6, TF_BASE+TF_REG_T6(sp)
-	lw	t7, TF_BASE+TF_REG_T7(sp)
-	lw	t8, TF_BASE+TF_REG_T8(sp)
-	lw	t9, TF_BASE+TF_REG_T9(sp)
-	lw	ra, TF_BASE+TF_REG_RA(sp)
-	addu	sp, sp, KERNFRAME_SIZ
+
+	REG_L	AT, TF_BASE+TF_REG_AST(sp)
+	REG_L	v0, TF_BASE+TF_REG_V0(sp)
+	REG_L	v1, TF_BASE+TF_REG_V1(sp)
+	REG_L	a0, TF_BASE+TF_REG_A0(sp)
+	REG_L	a1, TF_BASE+TF_REG_A1(sp)
+	REG_L	a2, TF_BASE+TF_REG_A2(sp)
+	REG_L	a3, TF_BASE+TF_REG_A3(sp)
+	REG_L	t0, TF_BASE+TF_REG_T0(sp)
+	REG_L	t1, TF_BASE+TF_REG_T1(sp)
+	REG_L	t2, TF_BASE+TF_REG_T2(sp)
+	REG_L	t3, TF_BASE+TF_REG_T3(sp)
+	REG_L	ta0, TF_BASE+TF_REG_TA0(sp)
+	REG_L	ta1, TF_BASE+TF_REG_TA1(sp)
+	REG_L	ta2, TF_BASE+TF_REG_TA2(sp)
+	REG_L	ta3, TF_BASE+TF_REG_TA3(sp)
+	#REG_L	t8, TF_BASE+TF_REG_T8(sp)	# is MIPS_CURLWP
+	REG_L	t9, TF_BASE+TF_REG_T9(sp)
+	REG_L	ra, TF_BASE+TF_REG_RA(sp)
 #ifdef DDBnotyet
-	lw	s0, TF_BASE+TF_REG_S0(sp)
-	lw	s1, TF_BASE+TF_REG_S1(sp)
-	lw	s2, TF_BASE+TF_REG_S2(sp)
-	lw	s3, TF_BASE+TF_REG_S3(sp)
-	lw	s4, TF_BASE+TF_REG_S4(sp)
-	lw	s5, TF_BASE+TF_REG_S5(sp)
-	lw	s6, TF_BASE+TF_REG_S6(sp)
-	lw	s7, TF_BASE+TF_REG_S7(sp)
-	lw	sp, TF_BASE+TF_REG_SP(sp)
-	lw	s8, TF_BASE+TF_REG_S8(sp)
-	lw	gp, TF_BASE+TF_REG_GP(sp)
+	REG_L	s0, TF_BASE+TF_REG_S0(sp)
+	REG_L	s1, TF_BASE+TF_REG_S1(sp)
+	REG_L	s2, TF_BASE+TF_REG_S2(sp)
+	REG_L	s3, TF_BASE+TF_REG_S3(sp)
+	REG_L	s4, TF_BASE+TF_REG_S4(sp)
+	REG_L	s5, TF_BASE+TF_REG_S5(sp)
+	REG_L	s6, TF_BASE+TF_REG_S6(sp)
+	REG_L	s7, TF_BASE+TF_REG_S7(sp)
+	REG_L	s8, TF_BASE+TF_REG_S8(sp)
 #endif
+	PTR_ADDU sp, KERNFRAME_SIZ
 	j	k1				# return to interrupted point
 	rfe
 	.set	at
-END(mips1_kern_gen_exception)
-
-/*
- * mips1_user_gen_exception
+END(MIPSX(kern_gen_exception))
+
+/*
+ * mipsN_kern_intr
+ *
+ * Handle an interrupt from kernel mode.
+ * Build kernframe on stack to hold interrupted kernel context, then
+ * call cpu_intr() to process it.
+ *
+ */
+NESTED_NOPROFILE(MIPSX(kern_intr), KERNFRAME_SIZ, ra)
+	.set	noat
+	.mask	0x80000000, -4
+#ifdef PARANOIA
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
+	nop
+	slt	k0, k0, sp			# k0 = L_PCB(MIPS_CURLWP) < sp
+1:	beqz	k0, 1b				# loop forever if false
+	 nop
+	PTR_L	k0, L_PCB(MIPS_CURLWP)
+	nop
+	PTR_ADDU k0, USPACE
+	slt	k0, sp, k0			# k0 = sp < L_PCB(MIPS_CURLWP) + USPACE
+2:	beqz	k0, 2b				# loop forever if false
+	 nop
+	PTR_L	k0, L_CPU(MIPS_CURLWP)
+	nop
+	INT_L	k0, CPU_INFO_IDEPTH(k0)		# grab interrupt depth
+	nop
+	sltu	k0, k0, 3			# must be < 3
+3:	beqz	k0, 3b				# loop forever if false
+	 nop
+#endif
+	/*
+	 * Save the relevant kernel registers onto the stack.  We don't need
+	 * to save s0 - s8, sp, and gp because the compiler does it for us.
+	 * But we use s0-s2 so need to save them.
+	 */
+	PTR_SUBU sp, KERNFRAME_SIZ
+	REG_S	AT, TF_BASE+TF_REG_AST(sp)
+	REG_S	v0, TF_BASE+TF_REG_V0(sp)
+	REG_S	v1, TF_BASE+TF_REG_V1(sp)
+	mflo	v0
+	mfhi	v1
+	REG_S	a0, TF_BASE+TF_REG_A0(sp)
+	REG_S	a1, TF_BASE+TF_REG_A1(sp)
+	REG_S	a2, TF_BASE+TF_REG_A2(sp)
+	REG_S	a3, TF_BASE+TF_REG_A3(sp)
+	REG_S	t0, TF_BASE+TF_REG_T0(sp)
+	REG_S	t1, TF_BASE+TF_REG_T1(sp)
+	REG_S	t2, TF_BASE+TF_REG_T2(sp)
+	REG_S	t3, TF_BASE+TF_REG_T3(sp)
+	REG_S	ta0, TF_BASE+TF_REG_TA0(sp)
+	REG_S	ta1, TF_BASE+TF_REG_TA1(sp)
+	REG_S	ta2, TF_BASE+TF_REG_TA2(sp)
+	REG_S	ta3, TF_BASE+TF_REG_TA3(sp)
+	REG_S	s0, TF_BASE+TF_REG_S0(sp)	# used for saved ipl/idepth
+	REG_S	s1, TF_BASE+TF_REG_S1(sp)	# used for initial status
+	mfc0	s1, MIPS_COP_0_STATUS
+	REG_S	s2, TF_BASE+TF_REG_S2(sp)	# used for cpu_info
+	#REG_S	t8, TF_BASE+TF_REG_T8(sp)	# already contains MIPS_CURLWP
+	REG_S	t9, TF_BASE+TF_REG_T9(sp)
+	REG_S	ra, TF_BASE+TF_REG_RA(sp)
+	REG_S	s1, TF_BASE+TF_REG_SR(sp)
+	REG_S	v0, TF_BASE+TF_REG_MULLO(sp)
+	REG_S	v1, TF_BASE+TF_REG_MULHI(sp)
+/*
+ * Call the interrupt handler.
+ */
+	_MFC0	ta0, MIPS_COP_0_EXC_PC		# grab exception PC
+	PTR_L	s2, L_CPU(MIPS_CURLWP)		# delay slot
+	REG_S	ta0, TF_BASE+TF_REG_EPC(sp)	# and save it
+
+#if defined(DDB) || defined(DEBUG) || defined(KGDB)
+	REG_S	ta0, KERNFRAME_RA(sp)		# for debugging
+#endif
+
+#ifdef PARANOIA
+	INT_L	s0, CPU_INFO_CPL(s2)
+	nop					# load delay
+	INT_S	s0, TF_BASE+TF_PPL(sp)		# save priority level
+
+	/*
+	 * Verify the current interrupt level
+	 */
+	jal	_C_LABEL(splcheck)
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * We first need to get to IPL_HIGH so that interrupts are masked.
+	 */
+	jal	_C_LABEL(splhigh_noprof)
+	 nop
+
+#ifdef PARANOIA
+1:	bne	s0, v0, 1b
+	 nop
+#endif /* PARANOIA */
+
+	sll	s0, v0, 8			# remember previous priority
+						# low 8 bits used for idepth
+
+#ifdef PARANOIA
+	/*
+	 * Interrupts at IPL_HIGH are not allowed.
+	 */
+	li	v1, IPL_HIGH
+	sltu	t0, v0, v1
+2:	beqz	t0, 2b
+	 nop
+#endif /* PARANOIA */
+
+	INT_L	t1, CPU_INFO_IDEPTH(s2)		# we need to inc. intr depth
+	nop					# load delay
+	or	s0, t1				#   save old interrupt depth
+	INT_ADDU t1, 1
+	INT_S	t1, CPU_INFO_IDEPTH(s2)		#   store new interrupt depth
+
+	/*
+	 * Now we can enable interrupts since no interrupts can be delivered
+	 */
+	mfc0	v1, MIPS_COP_0_STATUS
+	nop
+	or	v0, v1, MIPS_SR_INT_IE
+	mtc0	v0, MIPS_COP_0_STATUS		# write new status
+
+	/*
+	 * Now hard interrupts can be processed.
+	 */
+	move	a1, ta0				# 2nd arg is exception PC
+	move	a2, s1				# 3rd arg is status
+	jal	_C_LABEL(cpu_intr)		# cpu_intr(ppl, pc, status)
+	 srl	a0, s0, 8			# 1st arg is previous pri level
+
+	and	t1, s0, 0xff			# get previous interrupt depth
+	INT_S	t1, CPU_INFO_IDEPTH(s2)		# to it previous value
+
+#ifdef PARANOIA
+	mfc0	t0, MIPS_COP_0_STATUS		# verify INT_IE is still set
+	nop
+	and	t0, MIPS_SR_INT_IE
+3:	beqz	t0, 3b
+	 nop
+#endif /* PARANOIA */
+
+#ifdef __HAVE_FAST_SOFTINTS
+	and	a0, s1, MIPS_SOFT_INT_MASK	# were softints enabled?
+	beqz	a0, 4f				#   nope
+	 nop
+	mfc0	v0, MIPS_COP_0_CAUSE		# grab the pending softints
+	nop
+	and	a0, v0				# are softints pending
+	beqz	a0, 4f				#   nope
+	 nop
+
+	jal	_C_LABEL(softint_process)	# softint_process(pending)
+	 nop
+
+#ifdef __HAVE_PREEMPTION
+	srl	v1, s0, 8			# get saved priority level
+	bnez	v1, 4f				# branch if not at IPL_NONE
+	 nop
+	INT_L	t0, CPU_INFO_SOFTINTS(s2)	# get pending softints
+	nop
+	and	v0, t0, 1 << SOFTINT_KPREEMPT	# do we need a kernel preempt?
+	beqz	v0, 4f				#   nope
+	 nop
+	xor	t0, v0				# clear preempt bit
+	INT_S	t0, CPU_INFO_SOFTINTS(s2)	# and save it.
+	jal	_C_LABEL(kpreempt)		# kpreempt(pc)
+	 PTR_L	a0, TF_BASE+TF_REG_EPC(sp)
+#endif /* __HAVE_PREEMPTION */
+4:
+#endif /* __HAVE_FAST_SOFTINT */
+	/*
+	 * Interrupts handled, restore registers and return from the interrupt.
+	 * First, clear interrupt enable
+	 */
+	mtc0	s1, MIPS_COP_0_STATUS		# disable interrupts
+
+	srl	a0, s0, 8			# get previous priority level
+#ifdef PARANOIA
+	INT_L	t0, TF_BASE+TF_PPL(sp)		# get saved priority level
+	nop
+9:	bne	t0, a0, 9b			# should still match
+	 nop
+
+	li	t0, IPL_HIGH
+	sltu	v0, a0, t0
+8:	beqz	v0, 8b
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * Restore IPL knowing interrupts are disabled
+	 */
+	jal	_C_LABEL(splx_noprof)		# splx(ppl)
+	 nop
+
+#ifdef PARANOIA
+	mfc0	v0, MIPS_COP_0_STATUS
+	nop
+	or	v0, MIPS_SR_INT_IE
+5:	bne	v0, s1, 5b
+	 nop
+#endif /* PARANOIA */
+
+	/*
+	 * Restore SR
+	 */
+	mtc0	s1, MIPS_COP_0_STATUS
+
+	/*
+	 * Restore s0-s2 and goto common kernel return code.
+	 */
+	REG_L	s0, TF_BASE+TF_REG_S0(sp)
+	REG_L	s1, TF_BASE+TF_REG_S1(sp)
+	b	MIPSX(kern_return)
+	 REG_L	s2, TF_BASE+TF_REG_S2(sp)
+	.set	at
+END(MIPSX(kern_intr))
+
+/*
+ * mipsN_user_gen_exception
  *
  * Handle an exception during user mode.
- * Save user context atop of kernel stack, then call trap() to process
+ * Save user context atop the kernel stack, then call trap() to process
  * the condition.  The context can be manipulated alternatively via
  * curlwp->l_md.md_regs.
  */
-NESTED_NOPROFILE(mips1_user_gen_exception, CALLFRAME_SIZ, ra)
+NESTED_NOPROFILE(MIPSX(user_gen_exception), CALLFRAME_SIZ, ra)
 	.set	noat
 	.mask	0x80000000, -4
-/*
- * Save all the registers but the kernel temporaries onto stack.
- */
-	lw	k1, CPUVAR(CURLWP)
-	nop
-	lw	k1, L_ADDR(k1)
-	nop
-	addu	k1, k1, USPACE - TF_SIZ
-	sw	AT, TF_REG_AST(k1)
-	sw	v0, TF_REG_V0(k1)
-	sw	v1, TF_REG_V1(k1)
+	/*
+	 * Save all the registers except the kernel temporaries onto the stack.
+	 */
+	PTR_L	k1, CPUVAR(CURLWP)
+	nop
+	PTR_L	k0, L_PCB(k1)
+	nop
+	PTR_ADDU k0, USPACE - TF_SIZ - CALLFRAME_SIZ
+	REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_V1(k0)
 	mflo	v0
-	sw	a0, TF_REG_A0(k1)
-	sw	a1, TF_REG_A1(k1)
-	sw	a2, TF_REG_A2(k1)
-	sw	a3, TF_REG_A3(k1)
+	REG_S	a0, CALLFRAME_SIZ+TF_REG_A0(k0)
+	REG_S	a1, CALLFRAME_SIZ+TF_REG_A1(k0)
+	REG_S	a2, CALLFRAME_SIZ+TF_REG_A2(k0)
+	REG_S	a3, CALLFRAME_SIZ+TF_REG_A3(k0)
 	mfhi	v1
-	sw	t0, TF_REG_T0(k1)
-	sw	t1, TF_REG_T1(k1)
-	sw	t2, TF_REG_T2(k1)
-	sw	t3, TF_REG_T3(k1)
+	REG_S	t0, CALLFRAME_SIZ+TF_REG_T0(k0)
+	REG_S	t1, CALLFRAME_SIZ+TF_REG_T1(k0)
+	REG_S	t2, CALLFRAME_SIZ+TF_REG_T2(k0)
+	REG_S	t3, CALLFRAME_SIZ+TF_REG_T3(k0)
 	mfc0	a0, MIPS_COP_0_STATUS		# 1st arg is STATUS
-	sw	t4, TF_REG_T4(k1)
-	sw	t5, TF_REG_T5(k1)
-	sw	t6, TF_REG_T6(k1)
-	sw	t7, TF_REG_T7(k1)
+	REG_S	ta0, CALLFRAME_SIZ+TF_REG_TA0(k0)
+	REG_S	ta1, CALLFRAME_SIZ+TF_REG_TA1(k0)
+	REG_S	ta2, CALLFRAME_SIZ+TF_REG_TA2(k0)
+	REG_S	ta3, CALLFRAME_SIZ+TF_REG_TA3(k0)
 	mfc0	a1, MIPS_COP_0_CAUSE		# 2nd arg is CAUSE
-	sw	s0, TF_REG_S0(k1)
-	sw	s1, TF_REG_S1(k1)
-	sw	s2, TF_REG_S2(k1)
-	sw	s3, TF_REG_S3(k1)
-	mfc0	a2, MIPS_COP_0_BAD_VADDR	# 3rd arg is fault address
-	sw	s4, TF_REG_S4(k1)
-	sw	s5, TF_REG_S5(k1)
-	sw	s6, TF_REG_S6(k1)
-	sw	s7, TF_REG_S7(k1)
-	mfc0	a3, MIPS_COP_0_EXC_PC		# 4th arg is exception PC
-	sw	t8, TF_REG_T8(k1)
-	sw	t9, TF_REG_T9(k1)
-	sw	gp, TF_REG_GP(k1)
-	sw	sp, TF_REG_SP(k1)
-	sw	s8, TF_REG_S8(k1)
-	sw	ra, TF_REG_RA(k1)
-	sw	a0, TF_REG_SR(k1)
-	sw	v0, TF_REG_MULLO(k1)
-	sw	v1, TF_REG_MULHI(k1)
-	sw	a3, TF_REG_EPC(k1)
-	addu	sp, k1, -CALLFRAME_SIZ		# switch to kernel SP
+	REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(k0)
+	REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(k0)
+	REG_S	s2, CALLFRAME_SIZ+TF_REG_S2(k0)
+	REG_S	s3, CALLFRAME_SIZ+TF_REG_S3(k0)
+	_MFC0	a2, MIPS_COP_0_BAD_VADDR	# 3rd arg is fault address
+	REG_S	s4, CALLFRAME_SIZ+TF_REG_S4(k0)
+	REG_S	s5, CALLFRAME_SIZ+TF_REG_S5(k0)
+	REG_S	s6, CALLFRAME_SIZ+TF_REG_S6(k0)
+	REG_S	s7, CALLFRAME_SIZ+TF_REG_S7(k0)
+	_MFC0	a3, MIPS_COP_0_EXC_PC		# 4th arg is exception PC
+	REG_S	t8, CALLFRAME_SIZ+TF_REG_T8(k0)	# will be MIPS_CURLWP
+	REG_S	t9, CALLFRAME_SIZ+TF_REG_T9(k0)
+	REG_S	gp, CALLFRAME_SIZ+TF_REG_GP(k0)
+	REG_S	sp, CALLFRAME_SIZ+TF_REG_SP(k0)
+	REG_S	s8, CALLFRAME_SIZ+TF_REG_S8(k0)
+	REG_S	ra, CALLFRAME_SIZ+TF_REG_RA(k0)
+	REG_S	a0, CALLFRAME_SIZ+TF_REG_SR(k0)
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_MULLO(k0)
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_MULHI(k0)
+	REG_S	a3, CALLFRAME_SIZ+TF_REG_EPC(k0)
 #ifdef __GP_SUPPORT__
-	la	gp, _C_LABEL(_gp)		# switch to kernel GP
+	PTR_LA	gp, _C_LABEL(_gp)		# switch to kernel GP
 #endif
-#ifndef NOFPU
+	move	sp, k0				# switch to kernel SP
+	move	MIPS_CURLWP, k1
+#ifdef NOFPU
+	li	t0, MIPS_SR_INT_IE		# reenable intrs
+#else
 	lui	t0, %hi(MIPS_SR_COP_1_BIT)
 	and	t0, a0
 	or	t0, MIPS_SR_INT_IE		# make sure intrs are still on
-#else
-	li	t0, MIPS_SR_INT_IE		# reenable intrs
 #endif
 	xor	t0, a0				# turn off the FPU & ints on
-#if defined(DDB) || defined(DEBUG) || defined(KGDB)
-	move	ra, a3
-	sw	ra, CALLFRAME_RA(sp)
-#endif
-/*
- * Call the exception handler.
- */
-	lw	MIPS_CURLWP, CPUVAR(CURLWP)
+/*
+ * Call the trap handler.
+ */
+	mtc0	t0, MIPS_COP_0_STATUS
+
 	jal	_C_LABEL(trap)
-	mtc0	t0, MIPS_COP_0_STATUS
+	 REG_S	a3, CALLFRAME_RA(sp)		# for debugging
 /*
  * Check pending asynchronous traps.
  */
-	lw	t0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
-	nop
-	beq	t0, zero, 1f			# if no, skip ast processing
-	nop
+	INT_L	v0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
+	nop
+	beqz	v0, MIPSX(user_return)		# if no, skip ast processing
+	 nop
 /*
  * We have pending asynchronous traps; all the state is already saved.
  */
-	jal	_C_LABEL(ast)
-	lw	a0, CALLFRAME_SIZ + TF_REG_EPC(sp)
-1:
-	la	ra, _C_LABEL(mips1_xcpt_return)
-	j	ra				# pretend function return
-	nop
+	lui	ra, %hi(MIPSX(user_return))	# return directly to user return
+	j	_C_LABEL(ast)
+	 PTR_ADDIU ra, %lo(MIPSX(user_return))	# return directly to user return
 	.set	at
-END(mips1_user_gen_exception)
-
-/*
- * mips1_SystemCall
- *
- * Save user context atop of kernel stack, then call syscall() to process
- * the condition.  The context can be manipulated alternatively via
- * curlwp->l_md.md_regs.
- */
-NESTED_NOPROFILE(mips1_systemcall, CALLFRAME_SIZ, ra)
+END(MIPSX(user_gen_exception))
+
+/*----------------------------------------------------------------------------
+ *
+ * mipsN_user_intr
+ *
+ *	Handle an interrupt from user mode.
+ *	We save partial state onto the kernel stack since we know there will
+ *	always a kernel stack and chances are we won't need the registers we
+ *	don't save.  If there is a pending asynchronous system trap, then save
+ *	the remaining state and call ast().
+ *
+ * Results:
+ * 	None.
+ *
+ * Side effects:
+ *	None.
+ *
+ *----------------------------------------------------------------------------
+ */
+NESTED_NOPROFILE(MIPSX(user_intr), CALLFRAME_SIZ, ra)
 	.set	noat
 	.mask	0x80000000, -4
 /*
- * Save all the registers but kernel temporaries onto stack.
- */
-	lw	k1, CPUVAR(CURLWP)
-	nop
-	lw	k1, L_ADDR(k1)
-	nop
-	addu	k1, k1, USPACE - TF_SIZ
-	#sw	AT, TF_REG_AST(k1)
+ * Save the relevant user registers onto the kernel stack.
+ * We don't need to save s0 - s8 because the compiler does it for us.
+ */
+	PTR_L	k1, CPUVAR(CURLWP)
+	nop
+	PTR_L	k0, L_PCB(k1)				# XXXuvm_lwp_getuarea
+	nop
+	PTR_ADDU k0, USPACE - TF_SIZ - CALLFRAME_SIZ
+	REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)	# $1
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)		# $2
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_V1(k0)		# $3
+	mflo	v0
+	REG_S	a0, CALLFRAME_SIZ+TF_REG_A0(k0)		# $4
+	REG_S	a1, CALLFRAME_SIZ+TF_REG_A1(k0)		# $5
+	REG_S	a2, CALLFRAME_SIZ+TF_REG_A2(k0)		# $6
+	REG_S	a3, CALLFRAME_SIZ+TF_REG_A3(k0)		# $7
+	mfhi	v1
+	REG_S	t0, CALLFRAME_SIZ+TF_REG_T0(k0)		# $8
+	REG_S	t1, CALLFRAME_SIZ+TF_REG_T1(k0)		# $9
+	REG_S	t2, CALLFRAME_SIZ+TF_REG_T2(k0)		# $10
+	REG_S	t3, CALLFRAME_SIZ+TF_REG_T3(k0)		# $11
+	mfc0	t0, MIPS_COP_0_CAUSE
+	REG_S	ta0, CALLFRAME_SIZ+TF_REG_TA0(k0)	# $12
+	REG_S	ta1, CALLFRAME_SIZ+TF_REG_TA1(k0)	# $13
+	REG_S	ta2, CALLFRAME_SIZ+TF_REG_TA2(k0)	# $14
+	REG_S	ta3, CALLFRAME_SIZ+TF_REG_TA3(k0)	# $15
+	REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(k0)		# $16
+	REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(k0)		# $17
+	mfc0	s1, MIPS_COP_0_STATUS
+	REG_S	t8, CALLFRAME_SIZ+TF_REG_T8(k0)		# $24 MIPS_CURLWP
+	REG_S	t9, CALLFRAME_SIZ+TF_REG_T9(k0)		# $25
+	REG_S	gp, CALLFRAME_SIZ+TF_REG_GP(k0)		# $28
+	REG_S	sp, CALLFRAME_SIZ+TF_REG_SP(k0)		# $29
+	REG_S	ra, CALLFRAME_SIZ+TF_REG_RA(k0)		# $31
+	REG_S	s1, CALLFRAME_SIZ+TF_REG_SR(k0)
+	_MFC0	ta0, MIPS_COP_0_EXC_PC
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_MULLO(k0)
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_MULHI(k0)
+	REG_S	ta0, CALLFRAME_SIZ+TF_REG_EPC(k0)
+	REG_S	t0, CALLFRAME_SIZ+TF_REG_CAUSE(k0)
+	move	sp, k0				# switch to kernel SP
+	move	MIPS_CURLWP, k1			# set curlwp reg (t8)
+#if defined(DDB) || defined(DEBUG) || defined(KGDB)
+	REG_S	ta0, CALLFRAME_RA(sp)		# for debugging
+#endif
+#ifdef __GP_SUPPORT__
+	PTR_LA	gp, _C_LABEL(_gp)		# switch to kernel GP
+#endif
+
+	/*
+	 * We first need to get to IPL_HIGH so that interrupts are masked.
+	 */
+	jal	_C_LABEL(splhigh_noprof)	# splhigh()
+	 nop
+	move	s0, v0				# remember previous priority
+
+	/*
+	 * Now that we are at IPL_HIGH, we can turn off FPU and turn on
+	 * interrupts since they all masked.
+	 */
+	mfc0	v1, MIPS_COP_0_STATUS
+#ifndef NOFPU
+	lui	v0, %hi(MIPS_SR_COP_1_BIT)
+	and	v0, v1
+	or	v0, MIPS_SR_INT_IE		# make sure intrs are still on
+#else
+	li	v0, MIPS_SR_INT_IE		# reenable intrs
+#endif
+	xor	v0, v1
+	mtc0	v0, MIPS_COP_0_STATUS
+	nop
+
+	/*
+	 * Since we interrupted user mode, the new interrupt depth must be 1.
+	 */
+	PTR_L	t0, L_CPU(MIPS_CURLWP)
+	li	t1, 1
+	INT_S	t1, CPU_INFO_IDEPTH(t0)		# store new interrupt depth (1)
+
+	/*
+	 * Now hard interrupts can be processed.
+	 */
+	move	a1, ta0				# 2nd arg is exception pc
+	move	a2, s1				# 3rd arg is status
+	jal	_C_LABEL(cpu_intr)		# cpu_intr(ppl, pc, status)
+	 move	a0, s0				# 1st arg is previous pri level
+
+	/*
+	 * Interrupt depth is now back to 0.
+	 */
+	PTR_L	t0, L_CPU(MIPS_CURLWP)
+	nop
+	INT_S	zero, CPU_INFO_IDEPTH(t0)
+
+#ifdef __HAVE_FAST_SOFTINTS
+	/*
+	 * This an interrupt from user mode so both softints must be enabled.
+	 * No need to check (unless we're being paranoid).
+	 */
+#ifdef PARANOIA
+	and	a0, s1, MIPS_SOFT_INT_MASK	# get softints enabled bits
+	xor	a0, MIPS_SOFT_INT_MASK		# invert them.
+1:	bnez	a0, 1b				# loop forever if disabled
+	 nop
+#endif
+	mfc0	a0, MIPS_COP_0_CAUSE		# grab the pending softints
+	nop					# load delay
+	and	a0, MIPS_SOFT_INT_MASK		# are there softints pending
+	beqz	a0, 4f				#   nope
+	 nop
+	jal	_C_LABEL(softint_process)	# softint_process(pending)
+	 nop
+4:
+#endif
+	/*
+	 * Disable interrupts
+	 */
+	mfc0	v1, MIPS_COP_0_STATUS
+	nop					# delay slot
+	and	v0, v1, MIPS_SR_INT_IE		# clear interrupt enable
+	xor	v0, v1
+	mtc0	v0, MIPS_COP_0_STATUS		# interrupts are disabled
+
+	/*
+	 * Restore IPL knowing interrupts are off
+	 */
+	jal	_C_LABEL(splx_noprof)
+	 move	a0, s0				# fetch previous priority level
+
+	/*
+	 * Check pending asynchronous traps.
+	 */
+	REG_L	s0, CALLFRAME_SIZ+TF_REG_S0(sp)	# restore
+	REG_L	s1, CALLFRAME_SIZ+TF_REG_S1(sp)	# restore
+	INT_L	v0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
+	nop
+	beqz	v0, MIPSX(user_intr_return)	# if no, skip ast processing
+	 nop
+
+	/*
+	 * We have a pending asynchronous trap; save remaining user state into
+	 * trapframe.
+	 */
+	#REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(sp)	# $16 (saved above)
+	#REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(sp)	# $17 (saved above)
+	REG_S	s2, CALLFRAME_SIZ+TF_REG_S2(sp)	# $18
+	REG_S	s3, CALLFRAME_SIZ+TF_REG_S3(sp)	# $19
+	REG_S	s4, CALLFRAME_SIZ+TF_REG_S4(sp)	# $20
+	REG_S	s5, CALLFRAME_SIZ+TF_REG_S5(sp)	# $21
+	REG_S	s6, CALLFRAME_SIZ+TF_REG_S6(sp)	# $22
+	REG_S	s7, CALLFRAME_SIZ+TF_REG_S7(sp)	# $23
+	REG_S	s8, CALLFRAME_SIZ+TF_REG_S8(sp)	# $30
+
+	mfc0	t0, MIPS_COP_0_STATUS
+	PTR_LA	ra, MIPSX(user_return)		# load delay
+	or	t0, MIPS_SR_INT_IE		# enable interrupts
+	j	_C_LABEL(ast)			# ast()
+	 mtc0	t0, MIPS_COP_0_STATUS		# enable interrupts (spl0)
 	.set	at
-	sw	v0, TF_REG_V0(k1)		# syscall #
-	sw	v1, TF_REG_V1(k1)		# used by syscall()
+END(MIPSX(user_intr))
+
+/*
+ * mipsN_systemcall
+ *
+ * Save user context atop of kernel stack, then call syscall() to process
+ * a system call.  The context can be manipulated alternatively via
+ * curlwp->l_md.md_utf->tf_regs.
+ */
+NESTED_NOPROFILE(MIPSX(systemcall), CALLFRAME_SIZ, ra)
+	.set	noat
+	.mask	0x80000000, -4
+	/*
+	 * Save all the registers but kernel temporaries onto the stack.
+	 */
+	PTR_L	k1, CPUVAR(CURLWP)
+	nop
+	PTR_L	k0, L_PCB(k1)
+	nop
+	PTR_ADDU k0, USPACE - TF_SIZ - CALLFRAME_SIZ
+	#REG_S	AT, CALLFRAME_SIZ+TF_REG_AST(k0)
+	#.set	at
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_V0(k0)		# syscall #
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_V1(k0)		# used by syscall()
 	mflo	v0
-	sw	a0, TF_REG_A0(k1)
-	sw	a1, TF_REG_A1(k1)
-	sw	a2, TF_REG_A2(k1)
-	sw	a3, TF_REG_A3(k1)
-	lw	a0, CPUVAR(CURLWP)		# 1st arg is curlwp
+	REG_S	a0, CALLFRAME_SIZ+TF_REG_A0(k0)
+	REG_S	a1, CALLFRAME_SIZ+TF_REG_A1(k0)
+	REG_S	a2, CALLFRAME_SIZ+TF_REG_A2(k0)
+	REG_S	a3, CALLFRAME_SIZ+TF_REG_A3(k0)
+	move	a0, k1					# 1st arg is curlwp
 	mfhi	v1
-	#sw	t0, TF_REG_T0(k1)		# no need to save temp regs
-	#sw	t1, TF_REG_T1(k1)
-	#sw	t2, TF_REG_T2(k1)
-	#sw	t3, TF_REG_T3(k1)
-	mfc0	a1, MIPS_COP_0_STATUS		# 2nd arg is STATUS
-	#sw	t4, TF_REG_T4(k1)
-	#sw	t5, TF_REG_T5(k1)
-	#sw	t6, TF_REG_T6(k1)
-	sw	t7, TF_REG_T7(k1)
-	mfc0	a2, MIPS_COP_0_CAUSE		# 3rd arg is CAUSE
-	sw	s0, TF_REG_S0(k1)
-	sw	s1, TF_REG_S1(k1)
-	sw	s2, TF_REG_S2(k1)
-	sw	s3, TF_REG_S3(k1)
-	mfc0	a3, MIPS_COP_0_EXC_PC		# 4th arg is PC
-	sw	s4, TF_REG_S4(k1)
-	sw	s5, TF_REG_S5(k1)
-	sw	s6, TF_REG_S6(k1)
-	sw	s7, TF_REG_S7(k1)
-	#sw	t8, TF_REG_T8(k1)
-	#sw	t9, TF_REG_T9(k1)
-	sw	gp, TF_REG_GP(k1)
-	sw	sp, TF_REG_SP(k1)
-	sw	s8, TF_REG_S8(k1)
-	sw	ra, TF_REG_RA(k1)
-	sw	a1, TF_REG_SR(k1)
-	sw	v0, TF_REG_MULLO(k1)
-	sw	v1, TF_REG_MULHI(k1)
-	sw	a3, TF_REG_EPC(k1)
-	addu	sp, k1, -CALLFRAME_SIZ		# switch to kernel SP
+	mfc0	a1, MIPS_COP_0_STATUS			# 2nd arg is STATUS
+	REG_S	s0, CALLFRAME_SIZ+TF_REG_S0(k0)
+	REG_S	s1, CALLFRAME_SIZ+TF_REG_S1(k0)
+	REG_S	s2, CALLFRAME_SIZ+TF_REG_S2(k0)
+	REG_S	s3, CALLFRAME_SIZ+TF_REG_S3(k0)
+	mfc0	a2, MIPS_COP_0_CAUSE			# 3rd arg is CAUSE
+	REG_S	s4, CALLFRAME_SIZ+TF_REG_S4(k0)
+	REG_S	s5, CALLFRAME_SIZ+TF_REG_S5(k0)
+	REG_S	s6, CALLFRAME_SIZ+TF_REG_S6(k0)
+	REG_S	s7, CALLFRAME_SIZ+TF_REG_S7(k0)
+	_MFC0	a3, MIPS_COP_0_EXC_PC			# 4th arg is PC
+	REG_S	t0, CALLFRAME_SIZ+TF_REG_T0(k0)
+	REG_S	t1, CALLFRAME_SIZ+TF_REG_T1(k0)
+	REG_S	t2, CALLFRAME_SIZ+TF_REG_T2(k0)
+	REG_S	t3, CALLFRAME_SIZ+TF_REG_T3(k0)		# syscall saved gp for fork
+	REG_S	ta0, CALLFRAME_SIZ+TF_REG_TA0(k0)
+	REG_S	ta1, CALLFRAME_SIZ+TF_REG_TA1(k0)
+	REG_S	ta2, CALLFRAME_SIZ+TF_REG_TA2(k0)
+	REG_S	ta3, CALLFRAME_SIZ+TF_REG_TA3(k0)
+	REG_S	t8, CALLFRAME_SIZ+TF_REG_T8(k0)		# will be MIPS_CURLWP
+	REG_S	t9, CALLFRAME_SIZ+TF_REG_T9(k0)
+	REG_S	gp, CALLFRAME_SIZ+TF_REG_GP(k0)
+	REG_S	sp, CALLFRAME_SIZ+TF_REG_SP(k0)
+	REG_S	s8, CALLFRAME_SIZ+TF_REG_S8(k0)
+	REG_S	ra, CALLFRAME_SIZ+TF_REG_RA(k0)
+	REG_S	a1, CALLFRAME_SIZ+TF_REG_SR(k0)
+	REG_S	v0, CALLFRAME_SIZ+TF_REG_MULLO(k0)
+	REG_S	v1, CALLFRAME_SIZ+TF_REG_MULHI(k0)
+	REG_S	a3, CALLFRAME_SIZ+TF_REG_EPC(k0)
+	PTR_L	t0, L_PROC(a0)			# curlwp->l_proc (used below)
+	move	sp, k0				# switch to kernel SP
+	move	MIPS_CURLWP, a0			# set curlwp reg
 #ifdef __GP_SUPPORT__
-	la	gp, _C_LABEL(_gp)		# switch to kernel GP
+	PTR_LA	gp, _C_LABEL(_gp)		# switch to kernel GP
 #endif
 #if defined(DDB) || defined(DEBUG) || defined(KGDB)
 	move	ra, a3
-	sw	ra, CALLFRAME_RA(sp)
+	REG_S	ra, CALLFRAME_RA(sp)
 #endif
-	lw	t0, L_PROC(a0)			# t0 = curlwp->l_proc
-	move	MIPS_CURLWP, a0			# set curlwp reg
-	lw	t1, P_MD_SYSCALL(t0)		# t1 = syscall
-	ori	t0, a1, MIPS_SR_INT_IE		# turn on IEc, enable intr.
-	and	t0, t0, ~MIPS_SR_COP_1_BIT	# turn off FPU
+	/*
+	 * Turn off FPU
+	 */
+	PTR_L	t9, P_MD_SYSCALL(t0)		# t1 = syscall
+#ifdef NOFPU
+	li	t0, MIPS_SR_INT_IE
+#else
+	lui	t0, %hi(MIPS_SR_COP_1_BIT)
+	and	t0, a1
+	ori	t0, MIPS_SR_INT_IE		# turn on IEc, enable intr.
+#endif
+	xor	t0, a1				# turns off the FPU & ints on
+	mtc0	t0, MIPS_COP_0_STATUS		# re-enable interrupts
 /*
  * Call the system call handler.
  */
-	jal	t1
-	mtc0	t0, MIPS_COP_0_STATUS
+	jalr	t9
+	 nop
 /*
  * Check pending asynchronous traps.
  */
-	lw	t0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
-	nop
-	beq	t0, zero, 1f
-	nop
+	INT_L	v0, L_MD_ASTPENDING(MIPS_CURLWP)# any pending ast?
+	nop
+	beqz	v0, MIPSX(user_return)		# no, skip ast processing
+	 nop
 /*
  * We have pending asynchronous traps; all the state is already saved.
  */
-	jal	_C_LABEL(ast)
-	lw	a0, CALLFRAME_SIZ + TF_REG_EPC(sp)
-1:
-	la	ra, _C_LABEL(mips1_xcpt_return)
-	j	ra				# pretend function return
-	nop
-END(mips1_systemcall)
-
-/*
- * mips1_kernIntr
- *
- * Handle an interrupt from kernel mode.
- * Build kernframe on stack to hold interrupted kernel context, then
- * call cpu_intr() to process it.
- *
- */
-NESTED_NOPROFILE(mips1_kern_intr, KERNFRAME_SIZ, ra)
-	.set	noat
-	.mask	0x80000000, (CALLFRAME_RA - KERNFRAME_SIZ)
-	subu	sp, sp, KERNFRAME_SIZ
-/*
- * Save the relevant kernel registers onto the stack.
- * We don't need to save s0 - s8 and sp because
- * the compiler does it for us.
- */
-	sw	AT, TF_BASE+TF_REG_AST(sp)
-	sw	v0, TF_BASE+TF_REG_V0(sp)
-	sw	v1, TF_BASE+TF_REG_V1(sp)
-	mflo	v0
-	mfhi	v1
-	sw	a0, TF_BASE+TF_REG_A0(sp)
-	sw	a1, TF_BASE+TF_REG_A1(sp)
-	sw	a2, TF_BASE+TF_REG_A2(sp)
-	sw	a3, TF_BASE+TF_REG_A3(sp)
-	mfc0	a0, MIPS_COP_0_STATUS		# 1st arg is STATUS
-	sw	t0, TF_BASE+TF_REG_T0(sp)
-	sw	t1, TF_BASE+TF_REG_T1(sp)
-	sw	t2, TF_BASE+TF_REG_T2(sp)
-	sw	t3, TF_BASE+TF_REG_T3(sp)
-	mfc0	a1, MIPS_COP_0_CAUSE		# 2nd arg is CAUSE
-	sw	t4, TF_BASE+TF_REG_T4(sp)
-	sw	t5, TF_BASE+TF_REG_T5(sp)
-	sw	t6, TF_BASE+TF_REG_T6(sp)
-	sw	t7, TF_BASE+TF_REG_T7(sp)
-	mfc0	a2, MIPS_COP_0_EXC_PC		# 3rd arg is exception PC
-	sw	t8, TF_BASE+TF_REG_T8(sp)
-	sw	t9, TF_BASE+TF_REG_T9(sp)
-	sw	ra, TF_BASE+TF_REG_RA(sp)
-	sw	a0, TF_BASE+TF_REG_SR(sp)
-	and	a3, a0, a1			# 4th is STATUS & CAUSE
-	sw	v0, TF_BASE+TF_REG_MULLO(sp)
-	sw	v1, TF_BASE+TF_REG_MULHI(sp)
-	sw	a2, TF_BASE+TF_REG_EPC(sp)
-#if defined(DDB) || defined(DEBUG) || defined(KGDB)
-	move	ra, a2
-	sw	ra, KERNFRAME_RA(sp)		# for debugging
-#endif
-/*
- * Call the interrupt handler.
- */
-	jal	_C_LABEL(cpu_intr)
-	nop
-/*
- * Restore registers and return from the interrupt.
- */
-	lw	a0, TF_BASE+TF_REG_SR(sp)
-	lw	t0, TF_BASE+TF_REG_MULLO(sp)
-	lw	t1, TF_BASE+TF_REG_MULHI(sp)
-	mtc0	a0, MIPS_COP_0_STATUS		# this should disable interrupts
-	mtlo	t0
-	mthi	t1
-/*
- * Check for kernel restartable atomic sequences.
- */
-	lw	k1, TF_BASE+TF_REG_EPC(sp)	# restore exception PC
-	la	t0, _C_LABEL(_lock_ras_start)
-	li	t1, -MIPS_LOCK_RAS_SIZE
-	and	t1, t1, k1
-	bne	t1, t0, 1f
-	nop
-	jal	_C_LABEL(_lock_ras)
-1:
-	lw	AT, TF_BASE+TF_REG_AST(sp)
-	lw	v0, TF_BASE+TF_REG_V0(sp)
-	lw	v1, TF_BASE+TF_REG_V1(sp)
-	lw	a0, TF_BASE+TF_REG_A0(sp)
-	lw	a1, TF_BASE+TF_REG_A1(sp)
-	lw	a2, TF_BASE+TF_REG_A2(sp)
-	lw	a3, TF_BASE+TF_REG_A3(sp)
-	lw	t0, TF_BASE+TF_REG_T0(sp)
-	lw	t1, TF_BASE+TF_REG_T1(sp)
-	lw	t2, TF_BASE+TF_REG_T2(sp)
-	lw	t3, TF_BASE+TF_REG_T3(sp)
-	lw	t4, TF_BASE+TF_REG_T4(sp)
-	lw	t5, TF_BASE+TF_REG_T5(sp)
-	lw	t6, TF_BASE+TF_REG_T6(sp)
-	lw	t7, TF_BASE+TF_REG_T7(sp)
-	lw	t8, TF_BASE+TF_REG_T8(sp)
-	lw	t9, TF_BASE+TF_REG_T9(sp)
-	lw	ra, TF_BASE+TF_REG_RA(sp)
-	addu	sp, sp, KERNFRAME_SIZ		# restore kernel SP
-	j	k1				# return to interrupted point
-	rfe
+	lui	ra, %hi(MIPSX(user_return))	# return directly to user return
+	j	_C_LABEL(ast)
+	 PTR_ADDIU ra, %lo(MIPSX(user_return))	# return directly to user return
 	.set	at
-END(mips1_kern_intr)
+END(MIPSX(systemcall))
 
 /*----------------------------------------------------------------------------
- * XXX this comment block should be updated XXX
- * mips1_user_intr --
- *
- *	Handle an interrupt from user mode.
- *	Note: we save minimal state in the u.u_pcb struct and use the standard
- *	kernel stack since there has to be a u page if we came from user mode.
- *	If there is a pending software interrupt, then save the remaining state
- *	and call softintr(). This is all because if we call switch() inside
- *	cpu_intr(), not all the user registers have been saved in u.u_pcb.
+ *      
+ *	R3000 TLB exception handlers
+ *      
+ *----------------------------------------------------------------------------
+ */
+
+/*----------------------------------------------------------------------------
+ *
+ * mipsN_kern_tlb_miss --
+ *
+ *	Handle a TLB miss exception from kernel mode in kernel space.
+ *	The BaddVAddr, Context, and EntryHi registers contain the failed
+ *	virtual address.
  *
  * Results:
- * 	None.
+ *	None.
  *
  * Side effects:
